package com.app;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.util.HashMap;
import java.util.Map;

@RestController
public class UploadDownloadController {

	private static final Logger logger = LoggerFactory.getLogger(UploadDownloadController.class);

	static StringBuilder data = new StringBuilder();

	@GetMapping("/download/{fileName:.+}")
	public ResponseEntity downloadFileFromLocal(@PathVariable String fileName) {
//		Path path = Paths.get(dataIn + fileName);
		Resource resource = null;
		try {
//			resource = new UrlResource(path.toUri());
			logger.info("DownloadFile: {}", fileName);
			resource = new ClassPathResource("classpath:data/"+fileName);

		} catch (Exception e) {
			logger.error(e.getMessage());
		}
		return ResponseEntity.ok()
//				.contentType(MediaType.parseMediaType("application/csv"))
				.header(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + resource.getFilename() + "\"")
				.body(resource);
	}


	@PostMapping("/upload")
	public void upload(@RequestParam MultipartFile file) {
		try{

			InputStream inputStream = file.getInputStream();
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
			String line;
			Map<String, Integer> salesMap = new HashMap<>();
			while ((line = bufferedReader.readLine()) != null) {
				String map[] = line.split("\t");
				salesMap.put(map[0].toUpperCase(),(int)Math.round(Double.parseDouble(map[1])));
			}

			StringBuilder salesData = new StringBuilder();
			salesData.append(salesMap.containsKey("ASUS")?salesMap.get("ASUS")+"," : "0,");
			salesData.append(salesMap.containsKey("APPLE")?salesMap.get("APPLE")+"," : "0,");
			salesData.append(salesMap.containsKey("DELL")?salesMap.get("DELL")+"," : "0,");
			salesData.append(salesMap.containsKey("LENOVO")?salesMap.get("LENOVO")+"," : "0,");
			salesData.append(salesMap.containsKey("SAMSUNG")?salesMap.get("SAMSUNG")+"," : "0,");
			salesData.append(salesMap.containsKey("SONY")?salesMap.get("SONY")+"," : "0,");
			salesData.append(salesMap.containsKey("TOSHIBA")?salesMap.get("TOSHIBA")+"," : "0,");

			bufferedReader.close();

			logger.info("UploadData: {}",salesData.toString());

			data.append(salesData.toString()+"\n");

		}catch(Exception ioe){
			logger.error(ioe.getMessage());
		}
	}

	@GetMapping("/data")
	public String getData() {
		return data.toString();
	}

}